- AnsibleFest
- Products
- Community
- Webinars & Training
- Blog

Documentation

# vmware_vswitch – Manage a VMware Standard Switch to an ESXi host

- Synopsis
- Requirements
- Parameters
- Notes
- Examples
- Return Values
- Status

## Synopsis

- This module can be used to add, remove and update a VMware Standard Switch to an ESXi host.

## Requirements

The below requirements are needed on the host that executes this module.

- python >= 2.6
- PyVmomi

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
esxi_hostname string added in 2.5 |  | Manage the vSwitch using this ESXi host system. aliases: host
hostname string |  | The hostname or IP address of the vSphere vCenter or ESXi server. If the value is not specified in the task, the value of environment variable `VMWARE_HOST` will be used instead. Environment variable support added in Ansible 2.6.
mtu integer | Default: 1500 | MTU to configure on vSwitch.
nics list | Default: [] | A list of vmnic names or vmnic name to attach to vSwitch. Alias `nics` is added in version 2.4. aliases: nic_name
number_of_ports integer | Default: 128 | Number of port to configure on vSwitch.
password string |  | The password of the vSphere vCenter or ESXi server. If the value is not specified in the task, the value of environment variable `VMWARE_PASSWORD` will be used instead. Environment variable support added in Ansible 2.6. aliases: pass, pwd
port integer added in 2.5 | Default: 443 | The port number of the vSphere vCenter or ESXi server. If the value is not specified in the task, the value of environment variable `VMWARE_PORT` will be used instead. Environment variable support added in Ansible 2.6.
proxy_host string added in 2.9 |  | Address of a proxy that will receive all HTTPS requests and relay them. The format is a hostname or a IP. If the value is not specified in the task, the value of environment variable `VMWARE_PROXY_HOST` will be used instead. This feature depends on a version of pyvmomi greater than v6.7.1.2018.12
proxy_port integer added in 2.9 |  | Port of the HTTP proxy that will receive all HTTPS requests and relay them. If the value is not specified in the task, the value of environment variable `VMWARE_PROXY_PORT` will be used instead.
state string | Choices: absent present ← | Add or remove the switch.
switch string / required |  | vSwitch name to add. Alias `switch` is added in version 2.4. aliases: switch_name
username string |  | The username of the vSphere vCenter or ESXi server. If the value is not specified in the task, the value of environment variable `VMWARE_USER` will be used instead. Environment variable support added in Ansible 2.6. aliases: admin, user
validate_certs boolean | Choices: no yes ← | Allows connection when SSL certificates are not valid. Set to `false` when certificates are not trusted. If the value is not specified in the task, the value of environment variable `VMWARE_VALIDATE_CERTS` will be used instead. Environment variable support added in Ansible 2.6. If set to `yes`, please make sure Python >= 2.7.9 is installed on the given machine.

## Notes

Note

- Tested on vSphere 5.5 and 6.5

## Examples

    - name: Add a VMware vSwitch
      vmware_vswitch:
        hostname: '{{ esxi_hostname }}'
        username: '{{ esxi_username }}'
        password: '{{ esxi_password }}'
        switch: vswitch_name
        nics: vmnic_name
        mtu: 9000
      delegate_to: localhost

    - name: Add a VMware vSwitch without any physical NIC attached
      vmware_vswitch:
        hostname: '{{ esxi_hostname }}'
        username: '{{ esxi_username }}'
        password: '{{ esxi_password }}'
        switch: vswitch_0001
        mtu: 9000
      delegate_to: localhost

    - name: Add a VMware vSwitch with multiple NICs
      vmware_vswitch:
        hostname: '{{ esxi_hostname }}'
        username: '{{ esxi_username }}'
        password: '{{ esxi_password }}'
        switch: vmware_vswitch_0004
        nics:
        - vmnic1
        - vmnic2
        mtu: 9000
      delegate_to: localhost

    - name: Add a VMware vSwitch to a specific host system
      vmware_vswitch:
        hostname: '{{ esxi_hostname }}'
        username: '{{ esxi_username }}'
        password: '{{ esxi_password }}'
        esxi_hostname: DC0_H0
        switch_name: vswitch_001
        nic_name: vmnic0
        mtu: 9000
      delegate_to: localhost

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
result string | always | information about performed operation Sample: vSwitch 'vSwitch_1002' is created successfully

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]
- This module is maintained by the Ansible Community. [community]

### Authors

- Joseph Callen (@jcpowermac)
- Russell Teague (@mtnbikenc)
- Abhijeet Kasurde (@Akasurde) <akasurde@redhat.com>

Hint

If you notice any issues in this documentation, you can edit this document to improve it.